## labplot 2.12.1

=== CMakeLists.txt ===
# see https://community.kde.org/Policies/CMake_Coding_Style
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)
project(labplot VERSION 2.12.0 LANGUAGES CXX C)
set(YEAR 2025)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_C_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(QT_MAJOR_VERSION 6)
set(QT_MIN_VERSION "6.5.0")
set(QT_VERSION_MAJOR ${QT_MAJOR_VERSION}) # used by QADS
add_definitions(-DQT_DISABLE_DEPRECATED_UP_TO=0x60000)

set(KF_MAJOR_VERSION "6")
set(KF_MIN_VERSION "6.3.0")

set(APPLE_SUPPRESS_X11_WARNING ON)

find_package(ECM ${KF_MIN_VERSION} REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
#include(KDEClangFormat)
#include(GenerateExportHeader)
include(FeatureSummary)

# build type: "release", "debug", "debugfull"
string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} NO_MODULE REQUIRED COMPONENTS
    Core
    Concurrent
    Gui
#     Qml
#     Quick
#     QuickWidgets
    PrintSupport
    Sql
    Widgets
    Test
)

# building QADS or Xlsx requires Qt${QT_VERSION_MAJOR}GuiPrivate (QADS is required, Xlsx is optional)
find_package(Qt${QT_MAJOR_VERSION}Gui ${QT_MIN_VERSION} CONFIG REQUIRED Private)

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Completion
    Config
    ConfigWidgets
    CoreAddons
    Crash
    I18n
    IconThemes
    KIO
    TextWidgets
    WidgetsAddons
    XmlGui
    NewStuffCore
    NewStuff
OPTIONAL_COMPONENTS
    DocTools
    Service
    Parts
    Purpose
    SyntaxHighlighting
)

# TODO: make NewStuff optional?
if(KF${KF_MAJOR_VERSION}NewStuff_FOUND)
    add_definitions(-DHAVE_KF_NEW_STUFF)
else()
    message(STATUS "KF NewStuff not found")
endif()
# TODO: service not used?
if(NOT KF${KF_MAJOR_VERSION}Service_FOUND)
    message(STATUS "KF Service not found")
endif()
# TODO: parts not used?
if(NOT KF${KF_MAJOR_VERSION}Parts_FOUND)
    message(STATUS "KF Parts not found")
endif()

if(KF${KF_MAJOR_VERSION}Purpose_FOUND)
    add_definitions(-DHAVE_PURPOSE)
endif()

if(KF${KF_MAJOR_VERSION}SyntaxHighlighting_FOUND)
    add_definitions(-DHAVE_KF_SYNTAX_HIGHLIGHTING)
else()
    message(STATUS "KF SyntaxHighlighting not found")
endif()

find_package(KF${KF_MAJOR_VERSION}UserFeedback QUIET)
if(KF${KF_MAJOR_VERSION}UserFeedback_FOUND)
    message(STATUS "Found KF${KF_MAJOR_VERSION}UserFeedback")
    add_definitions(-DHAVE_KUSERFEEDBACK)
else()
    message(STATUS "KF${KF_MAJOR_VERSION}UserFeedback not found")
endif()

find_package(BISON REQUIRED)

### compiler flags ######################################
option (ENABLE_COMPILER_OPTIMIZATION "Optimization: -OX" true)
if(${ENABLE_COMPILER_OPTIMIZATION})
    set(COMPILER_OPTIMIZATION_FLAG "-O2")
else()
    set(COMPILER_OPTIMIZATION_FLAG "-O0")
endif()
set (GENERIC_FLAGS "-Wall -Wextra -Wundef -Wpointer-arith -Wunreachable-code -Wunused -Wdeprecated-declarations -fno-omit-frame-pointer -fstack-protector-strong")
#set (GENERIC_GNU_FLAGS "${COMPILER_OPTIMIZATION_FLAG} -Wcast-align -Wswitch-enum -fvisibility=default -pedantic")
set (GENERIC_GNU_FLAGS "${COMPILER_OPTIMIZATION_FLAG} -Wcast-align -Wswitch-enum -fvisibility=default -pedantic -ffunction-sections -fdata-sections -pipe")
if(NOT APPLE)
    set (GENERIC_GNU_LINK_FLAGS "-Wl,--gc-sections -Wl,--as-needed -Wl,--no-undefined")
endif()
set (GENERIC_C_FLAGS "${GENERIC_FLAGS} -fno-exceptions")
# liborigin needs exceptions
set (GENERIC_CXX_FLAGS "${GENERIC_FLAGS} -fexceptions -std=c++17")

if("${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
    message(STATUS "GNU C compiler ${CMAKE_C_COMPILER_VERSION} detected, adding compile flags")
    # -flto is too heavy even with TMPDIR=/dev/shm
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GENERIC_C_FLAGS} ${GENERIC_GNU_FLAGS}")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${GENERIC_GNU_LINK_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${GENERIC_GNU_LINK_FLAGS}")
    if(CMAKE_C_COMPILER_VERSION VERSION_GREATER 10.99 AND CMAKE_C_COMPILER_VERSION VERSION_LESS 12)	# GCC 11 fails building readstat 1.1.8
        message(STATUS "Building ReadStat disabled due to GNU C compiler version 11")
        set(DONT_BUILD_READSTAT TRUE)
    endif()
    if(CMAKE_C_COMPILER_VERSION VERSION_GREATER_EQUAL 14) # overwrite -Werror=hardened to not fail
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-error=hardened")
    endif()
elseif("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
    message(STATUS "Clang C compiler ${CMAKE_C_COMPILER_VERSION} detected, adding compile flags")
    # even -flto=thin takes too long
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE ${GENERIC_C_FLAGS} ${GENERIC_GNU_FLAGS}")
    # TRY: -flto=thin -flto-jobs=2
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${GENERIC_GNU_LINK_FLAGS}")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${GENERIC_GNU_LINK_FLAGS}")
elseif("${CMAKE_C_COMPILER_ID}" MATCHES "Intel")
    message(STATUS "Intel C compiler detected, adding compile flags")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -O3 ${GENERIC_C_FLAGS}")
elseif("${CMAKE_C_COMPILER_ID}" MATCHES "PGI")
    message(STATUS "PGI C compiler detected, adding compile flags")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_GNU_SOURCE -O3 -D__GCC_ATOMIC_TEST_AND_SET_TRUEVAL=1 -Minform=inform -Mbounds -Mchkstk")
# " x" postfix to work around a bug in CMake that causes "MSVC" to translate to something completely different
elseif(("${CMAKE_C_COMPILER_ID} x" MATCHES "MSVC") OR MSVC)
    message(STATUS "MSVC C compiler detected, adding compile flags")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -W3")
    if(CMAKE_BUILD_TYPE STREQUAL Debug)
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Od")
    else()
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2")
    endif()
    set(MSVC_FOUND TRUE)
else()
    message(STATUS "UNKNOWN C compiler, adding compile flags")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${GENERIC_C_FLAGS}")
endif()
message(STATUS "CFLAGS =${CMAKE_C_FLAGS}")

if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
    if(QT_VERSION VERSION_GREATER_EQUAL 6.7.0 AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9")
	# see Qt supported compiler
        message(FATAL_ERROR "Insufficient GNU C++ version ${CMAKE_CXX_COMPILER_VERSION} (Qt 6.7+ requires at least GNU g++ 9)")
    else()
        message(STATUS "GNU C++ compiler ${CMAKE_CXX_COMPILER_VERSION} detected, adding compile flags")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GENERIC_CXX_FLAGS} ${GENERIC_GNU_FLAGS} -Wzero-as-null-pointer-constant")
	# see linker flags of gcc
    endif()
    if(CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 14) # overwrite -Werror=hardened to not fail
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=hardened")
    endif()
elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang")
    message(STATUS "Clang C++ compiler ${CMAKE_CXX_COMPILER_VERSION} detected, adding compile flags")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE ${GENERIC_CXX_FLAGS} ${GENERIC_GNU_FLAGS} -Wzero-as-null-pointer-constant")
    # see linker flags of clang
elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "Intel")
    message(STATUS "Intel C++ compiler detected, adding compile flags")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE ${GENERIC_CXX_FLAGS}")
    #-std=c++0x comes with cmake's general flags, deprecated in icc, remove it
    string(REPLACE "-std=c++0x" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
elseif("${CMAKE_CXX_COMPILER_ID}" MATCHES "PGI")
    message(STATUS "PGI C++ compiler detected, adding compile flags")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE -O3 -D__GCC_ATOMIC_TEST_AND_SET_TRUEVAL=1 -Minform=inform -Mbounds -Mchkstk")
# " x" postfix to work around a bug in CMake that causes "MSVC" to translate to something completely different
elseif(("${CMAKE_CXX_COMPILER_ID} x" MATCHES "MSVC") OR MSVC)
    message(STATUS "MSVC C++ compiler detected, adding compile flags")
    # -D_ALLOW_KEYWORD_MACROS for "#define private public" in MultiRangeTest.cpp
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W3 -DPSAPI_VERSION=1 /Zc:externC-")
    if(CMAKE_BUILD_TYPE STREQUAL Debug)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Od")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2")
    endif()
    set(MSVC_FOUND TRUE)
else()
    message(STATUS "UNKNOWN C++ compiler, adding compile flags")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${GENERIC_CXX_FLAGS}")
endif()
message(STATUS "CXXFLAGS =${CMAKE_CXX_FLAGS}")

##########################################################

# see also https://wiki.qt.io/Using_QString_Effectively
set(LABPLOT_COMPILE_DEFINITIONS
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_USE_FAST_CONCATENATION
    -DQT_USE_FAST_OPERATOR_PLUS
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
)
if(NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

include_directories(${CMAKE_SOURCE_DIR} ${CMAKE_BINARY_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
add_definitions(-DLVERSION=\"${labplot_VERSION}\")
add_definitions(-DYEAR=\"${YEAR}\")
add_definitions(-DCXX_COMPILER_ID=\"${CMAKE_CXX_COMPILER_ID}\")
add_definitions(-DCXX_COMPILER_VERSION=\"${CMAKE_CXX_COMPILER_VERSION}\")
add_definitions(-DCXX_COMPILER_FLAGS=\"${CMAKE_CXX_FLAGS}\")
set(BUILD_SHARED_LIBS true)

#cmake_policy(SET CMP0002 OLD)
if(CMAKE_VERSION VERSION_EQUAL "3.3" OR CMAKE_VERSION VERSION_GREATER "3.3")
    cmake_policy(SET CMP0063 NEW)
endif()

if(CMAKE_VERSION VERSION_GREATER "3.5")
  set(ENABLE_CLANG_TIDY OFF CACHE BOOL "Add clang-tidy automatically to builds")
  if(ENABLE_CLANG_TIDY)
    find_program (CLANG_TIDY_EXE NAMES "clang-tidy" PATHS /usr/bin)
    if(CLANG_TIDY_EXE)
      message(STATUS "Clang-tidy supported, found and enabled: ${CLANG_TIDY_EXE}")
      set(CLANG_TIDY_CHECKS "modernize-*,-modernize-use-trailing-return-type,clang-analyzer-*,-clang-analyzer-cplusplus*")
      #set(CLANG_TIDY_CHECKS "-*,modernize-*,clang-analyzer-*")
      # -extra-arg=--std=c++17
      set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY_EXE};-checks=${CLANG_TIDY_CHECKS};-header-filter='${CMAKE_SOURCE_DIR}/*'"
        CACHE STRING "" FORCE)
    else()
      message(AUTHOR_WARNING "clang-tidy not found!")
      set(CMAKE_CXX_CLANG_TIDY "" CACHE STRING "" FORCE) # delete it
    endif()
   else()
    message(STATUS "Clang-tidy supported but disabled")
  endif()
endif()

# get git commit hash
execute_process(
  COMMAND git describe --always --tags
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  OUTPUT_VARIABLE GIT_COMMIT
  OUTPUT_STRIP_TRAILING_WHITESPACE
)
add_definitions(-DGIT_COMMIT=\"${GIT_COMMIT}\")


### Options ######################################
option(ENABLE_CANTOR "Build with Cantor support" ON)
option(ENABLE_FFTW "Build with FFTW support" ON)
option(ENABLE_HDF5 "Build with HDF5 support" ON)
option(ENABLE_NETCDF "Build with NetCDF support" ON)
option(ENABLE_FITS "Build with FITS support" ON)
option(ENABLE_LIBCERF "Build with libcerf support" ON)
option(ENABLE_LIBORIGIN "Build with liborigin support" ON)
option(ENABLE_ROOT "Build with ROOT (CERN) support" ON)
# FreeBSD fails with missing csv.h
if("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")
    option(ENABLE_READSTAT "Build with ReadStat support" OFF)
else()

=== doc/CMakeLists.txt ===
########### install files ###############
#
#
kdoctools_create_handbook(index.docbook INSTALL_DESTINATION ${KDE_INSTALL_DOCBUNDLEDIR}/en SUBDIR ${PROJECT_NAME})
kdoctools_create_manpage(man-labplot.1.docbook 1 INSTALL_DESTINATION ${KDE_INSTALL_MANDIR})

=== icons/CMakeLists.txt ===
ecm_install_icons(
ICONS
128-apps-labplot.png
150-apps-labplot.png
16-apps-labplot.png
22-apps-labplot.png
256-apps-labplot.png
310-apps-labplot.png
32-apps-labplot.png
44-apps-labplot.png
48-apps-labplot.png
512-apps-labplot.png
64-apps-labplot.png
sc-apps-labplot.svgz
DESTINATION ${KDE_INSTALL_ICONDIR}/)
install(FILES org.kde.labplot.svg DESTINATION ${KDE_INSTALL_FULL_ICONDIR}/hicolor/scalable/apps/)

=== lib/CMakeLists.txt ===
cmake_policy(SET CMP0079 NEW)

set(FRONTEND_DIR ../src/frontend)
set(BACKEND_DIR ../src/backend)
set(TOOLS_DIR ../src/tools)

set(CMAKE_AUTOMOC ON)
set_property(SOURCE gsl_parser.hpp gsl_parser.cpp PROPERTY SKIP_AUTOMOC ON)

set(SRC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)

include(GenerateExportHeader)

set(FILTER_SOURCES
    ${BACKEND_DIR}/datasources/filters/AsciiFilter.cpp
    ${BACKEND_DIR}/datasources/filters/BinaryFilter.cpp
    ${BACKEND_DIR}/datasources/filters/CANFilter.cpp
    ${BACKEND_DIR}/datasources/filters/FITSFilter.cpp
    ${BACKEND_DIR}/datasources/filters/ImageFilter.cpp
    ${BACKEND_DIR}/datasources/filters/JsonFilter.cpp
    ${BACKEND_DIR}/datasources/filters/MatioFilter.cpp
    ${BACKEND_DIR}/datasources/filters/NetCDFFilter.cpp
    ${BACKEND_DIR}/datasources/filters/OdsFilter.cpp
    ${BACKEND_DIR}/datasources/filters/ROOTFilter.cpp
    ${BACKEND_DIR}/datasources/filters/SpiceFilter.cpp
    ${BACKEND_DIR}/datasources/filters/VectorBLFFilter.cpp
    ${BACKEND_DIR}/datasources/filters/XLSXFilter.cpp
    ${BACKEND_DIR}/datasources/filters/McapFilter.cpp
    ${BACKEND_DIR}/datasources/filters/HDF5Filter.cpp
    ${BACKEND_DIR}/datasources/filters/ReadStatFilter.cpp
)

set(DATA_CONTAINER_SOURCES
    ${BACKEND_DIR}/matrix/Matrix.cpp
    ${BACKEND_DIR}/spreadsheet/Spreadsheet.cpp
)

set(ASPECT_CONTAINER_SOURCES
    ${BACKEND_DIR}/core/Folder.cpp
    ${BACKEND_DIR}/core/Project.cpp
)

set(COLUMN_SOURCES
    ${BACKEND_DIR}/core/column/Column.cpp
)

set(WORKSHEET_SOURCES
    ${BACKEND_DIR}/worksheet/Worksheet.cpp
)

set(WORKSHEET_ELEMENT_SOURCES
    ${BACKEND_DIR}/worksheet/TextLabel.cpp
    ${BACKEND_DIR}/worksheet/InfoElement.cpp
    ${BACKEND_DIR}/worksheet/Image.cpp
)

set(WORKSHEET_ELEMENT_CONTAINER_SOURCES
    ${BACKEND_DIR}/worksheet/plots/cartesian/CartesianPlot.cpp
)

set(PLOT_AREA_ELEMENT_SOURCES
    ${BACKEND_DIR}/worksheet/plots/cartesian/Axis.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/CartesianPlotLegend.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/CustomPoint.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/ReferenceLine.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/ReferenceRange.cpp
)

set(PLOT_SOURCES
    ${BACKEND_DIR}/worksheet/plots/cartesian/BarPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/BoxPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/Histogram.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/KDEPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/LollipopPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/ProcessBehaviorChart.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/QQPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/RunChart.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYConvolutionCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYCorrelationCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYDataReductionCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYDifferentiationCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYEquationCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYFitCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYFourierFilterCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYFourierTransformCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYFunctionCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYHilbertTransformCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYIntegrationCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYInterpolationCurve.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYSmoothCurve.cpp
)

set(SDK_SOURCES
    ${FILTER_SOURCES}
    ${DATA_CONTAINER_SOURCES}
    ${ASPECT_CONTAINER_SOURCES}
    ${COLUMN_SOURCES}
    ${WORKSHEET_SOURCES}
    ${WORKSHEET_ELEMENT_SOURCES}
    ${WORKSHEET_ELEMENT_CONTAINER_SOURCES}
    ${PLOT_AREA_ELEMENT_SOURCES}
    ${PLOT_SOURCES}
)

set(NSL_SOURCES
    ${BACKEND_DIR}/nsl/nsl_baseline.cpp
    ${BACKEND_DIR}/nsl/nsl_conv.c
    ${BACKEND_DIR}/nsl/nsl_corr.c
    ${BACKEND_DIR}/nsl/nsl_dft.c
    ${BACKEND_DIR}/nsl/nsl_diff.c
    ${BACKEND_DIR}/nsl/nsl_filter.c
    ${BACKEND_DIR}/nsl/nsl_fit.c
    ${BACKEND_DIR}/nsl/nsl_geom.c
    ${BACKEND_DIR}/nsl/nsl_geom_linesim.c
    ${BACKEND_DIR}/nsl/nsl_hilbert.c
    ${BACKEND_DIR}/nsl/nsl_int.c
    ${BACKEND_DIR}/nsl/nsl_interp.c
    ${BACKEND_DIR}/nsl/nsl_kde.c
    ${BACKEND_DIR}/nsl/nsl_math.c
    ${BACKEND_DIR}/nsl/nsl_pcm.c
    ${BACKEND_DIR}/nsl/nsl_peak.cpp
    ${BACKEND_DIR}/nsl/nsl_randist.c
    ${BACKEND_DIR}/nsl/nsl_sf_basic.c
    ${BACKEND_DIR}/nsl/nsl_sf_kernel.c
    ${BACKEND_DIR}/nsl/nsl_sf_poly.c
    ${BACKEND_DIR}/nsl/nsl_sf_stats.c
    ${BACKEND_DIR}/nsl/nsl_sf_window.c
    ${BACKEND_DIR}/nsl/nsl_smooth.c
    ${BACKEND_DIR}/nsl/nsl_sort.c
    ${BACKEND_DIR}/nsl/nsl_stats.c
)

bison_target(GslParser
    ${BACKEND_DIR}/gsl/parser.ypp
    ${CMAKE_CURRENT_BINARY_DIR}/gsl_parser.cpp
)

set(GSL_SOURCES
    ${BISON_GslParser_OUTPUTS}
    ${BACKEND_DIR}/gsl/ExpressionParser.cpp
)

set(SDK_DEPENDENCY_SOURCES
    ${BACKEND_DIR}/core/AbstractAspect.cpp
    ${BACKEND_DIR}/core/AbstractColumn.cpp
    ${BACKEND_DIR}/datasources/AbstractDataSource.cpp
    ${BACKEND_DIR}/worksheet/WorksheetElement.cpp
    ${BACKEND_DIR}/core/AbstractPart.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/Plot.cpp
    ${BACKEND_DIR}/worksheet/plots/AbstractPlot.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/XYAnalysisCurve.cpp
    ${BACKEND_DIR}/datasources/filters/AbstractFileFilter.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/CartesianCoordinateSystem.cpp
    ${BACKEND_DIR}/worksheet/WorksheetElementContainer.cpp
    ${BACKEND_DIR}/worksheet/plots/AbstractCoordinateSystem.cpp
    ${BACKEND_DIR}/worksheet/Background.cpp
    ${BACKEND_DIR}/worksheet/Line.cpp
    ${BACKEND_DIR}/worksheet/plots/PlotArea.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/ErrorBar.cpp
    ${BACKEND_DIR}/spreadsheet/StatisticsSpreadsheet.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/Symbol.cpp
    ${BACKEND_DIR}/worksheet/plots/cartesian/Value.cpp
    ${BACKEND_DIR}/core/column/ColumnStringIO.cpp
    ${BACKEND_DIR}/lib/Range.h
    ${BACKEND_DIR}/worksheet/plots/cartesian/CartesianScale.cpp
)

set(SDK_INTERNAL_SOURCES
    ${FRONTEND_DIR}/worksheet/WorksheetView.cpp
    ${BACKEND_DIR}/core/datatypes/Double2DateTimeFilter.h
    ${BACKEND_DIR}/core/datatypes/Double2DayOfWeekFilter.h
    ${BACKEND_DIR}/core/datatypes/Double2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/Double2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/Double2MonthFilter.h
    ${BACKEND_DIR}/core/datatypes/Double2StringFilter.cpp
    ${BACKEND_DIR}/core/datatypes/Integer2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/Integer2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/Integer2DateTimeFilter.h
    ${BACKEND_DIR}/core/datatypes/Integer2DayOfWeekFilter.h
    ${BACKEND_DIR}/core/datatypes/Integer2MonthFilter.h
    ${BACKEND_DIR}/core/datatypes/Integer2StringFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2StringFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2DateTimeFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2MonthFilter.h
    ${BACKEND_DIR}/core/datatypes/BigInt2DayOfWeekFilter.h
    ${BACKEND_DIR}/core/datatypes/String2DayOfWeekFilter.h
    ${BACKEND_DIR}/core/datatypes/String2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/String2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/String2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/String2MonthFilter.h
    ${BACKEND_DIR}/core/datatypes/String2DateTimeFilter.cpp
    ${BACKEND_DIR}/core/datatypes/DateTime2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/DateTime2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/DateTime2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/DateTime2StringFilter.cpp
    ${BACKEND_DIR}/core/datatypes/Month2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/Month2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/Month2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/DayOfWeek2DoubleFilter.h
    ${BACKEND_DIR}/core/datatypes/DayOfWeek2IntegerFilter.h
    ${BACKEND_DIR}/core/datatypes/DayOfWeek2BigIntFilter.h
    ${BACKEND_DIR}/core/datatypes/SimpleCopyThroughFilter.h
    ${BACKEND_DIR}/core/AbstractFilter.cpp
    ${BACKEND_DIR}/core/AbstractSimpleFilter.cpp
    ${BACKEND_DIR}/core/column/ColumnPrivate.cpp
    ${BACKEND_DIR}/core/AbstractColumnPrivate.cpp
    ${BACKEND_DIR}/lib/SignallingUndoCommand.cpp
    ${BACKEND_DIR}/lib/Debug.cpp
    ${BACKEND_DIR}/datasources/filters/DBCParser.cpp
    ${BACKEND_DIR}/matrix/MatrixModel.cpp
    ${BACKEND_DIR}/spreadsheet/SpreadsheetModel.cpp
    ${BACKEND_DIR}/lib/hostprocess.cpp
    ${BACKEND_DIR}/datasources/filters/SpiceReader.cpp
    ${BACKEND_DIR}/core/AspectTreeModel.cpp
    ${BACKEND_DIR}/matrix/matrixcommands.cpp
    ${BACKEND_DIR}/datasources/filters/QJsonModel.cpp
    ${BACKEND_DIR}/gsl/Parser.cpp
    ${BACKEND_DIR}/gsl/functions.cpp
    ${BACKEND_DIR}/gsl/constants.cpp
    ${BACKEND_DIR}/core/Settings.cpp
    ${FRONTEND_DIR}/GuiTools.cpp
    ${FRONTEND_DIR}/ThemeHandler.cpp
    ${TOOLS_DIR}/ImageTools.cpp
    ${TOOLS_DIR}/TeXRenderer.cpp
    ${BACKEND_DIR}/core/abstractcolumncommands.cpp
    ${BACKEND_DIR}/core/column/columncommands.cpp
    ${BACKEND_DIR}/worksheet/TreeModel.cpp
    ${BACKEND_DIR}/core/Time.cpp
    ${BACKEND_DIR}/note/Note.cpp
    ${BACKEND_DIR}/datasources/projects/ProjectParser.cpp
    ${BACKEND_DIR}/worksheet/ResizeItem.cpp
    ${BACKEND_DIR}/lib/XmlStreamReader.cpp
)

if(ENABLE_LIBORIGIN)
    list(APPEND SDK_INTERNAL_SOURCES ${BACKEND_DIR}/datasources/projects/OriginProjectParser.cpp)
    list(APPEND SDK_INTERNAL_SOURCES ${BACKEND_DIR}/core/Workbook.cpp)
endif()

if(NOT MSVC_FOUND)
if(NOT LIBCERF_FOUND)
    list(APPEND NSL_SOURCES ${BACKEND_DIR}/nsl/Faddeeva.c)
endif()
endif()

add_library(liblabplot SHARED ${SDK_SOURCES} ${SDK_DEPENDENCY_SOURCES} ${SDK_INTERNAL_SOURCES} ${NSL_SOURCES} ${GSL_SOURCES} ${QTMOC_HDRS})
add_library(LabPlot::SDK ALIAS liblabplot)
add_dependencies(liblabplot labplotlib labplotbackendlib labplotnsllib)

set_target_properties(liblabplot PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION}
    EXPORT_NAME SDK
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN 1
    OUTPUT_NAME labplot
)

target_compile_definitions(liblabplot PRIVATE -DSDK ${LABPLOT_COMPILE_DEFINITIONS})

target_include_directories(liblabplot
    PRIVATE
    $<TARGET_PROPERTY:labplotlib,INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:labplotbackendlib,INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:labplotnsllib,INCLUDE_DIRECTORIES>
    # any dependent building me directly
    PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/../src>
    # any dependent not building me directly
    INTERFACE $<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/labplot>
)

target_link_libraries(liblabplot
    PRIVATE
    $<TARGET_PROPERTY:labplotlib,LINK_LIBRARIES>
    $<TARGET_PROPERTY:labplotbackendlib,LINK_LIBRARIES>
    $<TARGET_PROPERTY:labplotnsllib,LINK_LIBRARIES>
    PUBLIC
    Qt${QT_MAJOR_VERSION}::Core
    Qt${QT_MAJOR_VERSION}::Gui
    Qt${QT_MAJOR_VERSION}::Widgets
)

if(WIN32)
if(PSAPI)
    target_link_libraries(liblabplot PRIVATE ${PSAPI})
endif()
endif()

############## installation ################################
install(TARGETS liblabplot EXPORT LabPlotTargets DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} COMPONENT Devel)

# generate labplot_export.h + LABPLOT_EXPORT macro
generate_export_header(liblabplot BASE_NAME labplot)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/labplot_export.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot COMPONENT Devel)

install(FILES labplot.h DESTINATION ${KDE_INSTALL_INCLUDEDIR}/labplot/ COMPONENT Devel)

# top-level and dependency includes
set(SDK_AND_DEPENDENCY_SOURCES ${SDK_SOURCES} ${SDK_DEPENDENCY_SOURCES})
foreach(SDK_SOURCE IN LISTS SDK_AND_DEPENDENCY_SOURCES)

=== src/CMakeLists.txt ===
find_package(SharedMimeInfo REQUIRED)
set(FRONTEND_DIR "${CMAKE_CURRENT_LIST_DIR}/frontend")
set(BACKEND_DIR "${CMAKE_CURRENT_LIST_DIR}/backend")
set(CANTOR_DIR "${CMAKE_CURRENT_LIST_DIR}/cantor")
set(TOOLS_DIR "${CMAKE_CURRENT_LIST_DIR}/tools")
set(CMAKE_AUTOMOC ON)
set(SRC_BUILD_DIR ${CMAKE_CURRENT_BINARY_DIR} PARENT_SCOPE)

set(GUI_SOURCES
    ${FRONTEND_DIR}/AboutDialog.cpp
    ${FRONTEND_DIR}/DatasetModel.cpp
    ${FRONTEND_DIR}/GuiObserver.cpp
    ${FRONTEND_DIR}/GuiTools.cpp
    ${FRONTEND_DIR}/HistoryDialog.cpp
    ${FRONTEND_DIR}/MainWin.cpp
    ${FRONTEND_DIR}/PlotTemplateDialog.cpp
    ${FRONTEND_DIR}/ProjectExplorer.cpp
    ${FRONTEND_DIR}/SettingsDialog.cpp
    ${FRONTEND_DIR}/SettingsGeneralPage.cpp
    ${FRONTEND_DIR}/SettingsNotebookPage.cpp
    ${FRONTEND_DIR}/SettingsSpreadsheetPage.cpp
    ${FRONTEND_DIR}/SettingsWorksheetPage.cpp
    ${FRONTEND_DIR}/SettingsDatasetsPage.cpp
    ${FRONTEND_DIR}/SettingsPage.h
    ${FRONTEND_DIR}/TemplateHandler.cpp
    ${FRONTEND_DIR}/ThemeHandler.cpp
    ${FRONTEND_DIR}/examples/ExamplesDialog.cpp
    ${FRONTEND_DIR}/examples/ExamplesManager.cpp
    ${FRONTEND_DIR}/examples/ExamplesWidget.cpp
#     ${FRONTEND_DIR}/welcomescreen/WelcomeScreenHelper.cpp
    ${FRONTEND_DIR}/colormaps/ColorMapsWidget.cpp
    ${FRONTEND_DIR}/colormaps/ColorMapsDialog.cpp
    ${FRONTEND_DIR}/core/ContentDockWidget.cpp
    ${FRONTEND_DIR}/datapicker/DatapickerView.cpp
    ${FRONTEND_DIR}/datapicker/DatapickerImageView.cpp
    ${FRONTEND_DIR}/datasources/AsciiOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/CANOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/BinaryOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/DatabaseManagerDialog.cpp
    ${FRONTEND_DIR}/datasources/DatabaseManagerWidget.cpp
    ${FRONTEND_DIR}/datasources/DatasetMetadataManagerDialog.cpp
    ${FRONTEND_DIR}/datasources/DatasetMetadataManagerWidget.cpp
    ${FRONTEND_DIR}/datasources/OdsOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/XLSXOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/HDF5OptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ImageOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportDatasetWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportDatasetDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportWarningsDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportFileWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportFileDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportKaggleDatasetWidget.cpp
    ${FRONTEND_DIR}/datasources/ImportKaggleDatasetDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportOriginLayersDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportProjectDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportSQLDatabaseDialog.cpp
    ${FRONTEND_DIR}/datasources/ImportSQLDatabaseWidget.cpp
    ${FRONTEND_DIR}/datasources/MatioOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/NetCDFOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/ROOTOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/FITSOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/JsonOptionsWidget.cpp
    ${FRONTEND_DIR}/datasources/McapOptionsWidget.cpp
    ${FRONTEND_DIR}/dockwidgets/BaseDock.cpp
    ${FRONTEND_DIR}/dockwidgets/AspectDock.cpp
    ${FRONTEND_DIR}/dockwidgets/AxisDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CursorDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ImageDock.cpp
    ${FRONTEND_DIR}/dockwidgets/InfoElementDock.cpp
    ${FRONTEND_DIR}/dockwidgets/NoteDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CartesianPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CartesianPlotLegendDock.cpp
    ${FRONTEND_DIR}/dockwidgets/HistogramDock.cpp
    ${FRONTEND_DIR}/dockwidgets/BarPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/BoxPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/CustomPointDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ColumnDock.cpp
    ${FRONTEND_DIR}/dockwidgets/KDEPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/LiveDataDock.cpp
    ${FRONTEND_DIR}/dockwidgets/LollipopPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/MatrixDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ProcessBehaviorChartDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ProjectDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ReferenceLineDock.cpp
    ${FRONTEND_DIR}/dockwidgets/ReferenceRangeDock.cpp
    ${FRONTEND_DIR}/dockwidgets/RunChartDock.cpp
    ${FRONTEND_DIR}/dockwidgets/SpreadsheetDock.cpp
    ${FRONTEND_DIR}/dockwidgets/StatisticsSpreadsheetDock.cpp
    ${FRONTEND_DIR}/dockwidgets/QQPlotDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYAnalysisCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYEquationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFunctionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYDataReductionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYDifferentiationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYIntegrationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYInterpolationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYSmoothCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFitCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFourierFilterCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYFourierTransformCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYHilbertTransformCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYConvolutionCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/XYCorrelationCurveDock.cpp
    ${FRONTEND_DIR}/dockwidgets/WorksheetDock.cpp
    ${FRONTEND_DIR}/matrix/MatrixFunctionDialog.cpp
    ${FRONTEND_DIR}/matrix/MatrixView.cpp
    ${FRONTEND_DIR}/note/NoteView.cpp
    ${FRONTEND_DIR}/spreadsheet/PlotDataDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/EquidistantValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/ExportSpreadsheetDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/AddSubtractValueDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/AddValueLabelDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/BatchEditValueLabelsDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/DropValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FlattenColumnsDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FormattingHeatmapDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/GoToDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/FunctionValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/RandomValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/RescaleDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/SampleValuesDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/SearchReplaceWidget.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetCommentsHeaderModel.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetHeaderView.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetSparkLineHeaderModel.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetItemDelegate.cpp
    ${FRONTEND_DIR}/spreadsheet/SparklineRunnable.h
    ${FRONTEND_DIR}/spreadsheet/SparklineRunnable.cpp
    ${FRONTEND_DIR}/spreadsheet/SpreadsheetView.cpp
    ${FRONTEND_DIR}/spreadsheet/SortDialog.cpp
    ${FRONTEND_DIR}/spreadsheet/StatisticsColumnWidget.cpp
    ${FRONTEND_DIR}/spreadsheet/StatisticsDialog.cpp
    ${FRONTEND_DIR}/worksheet/ExportWorksheetDialog.cpp
    ${FRONTEND_DIR}/worksheet/GridDialog.cpp
    ${FRONTEND_DIR}/worksheet/PresenterWidget.cpp
    ${FRONTEND_DIR}/worksheet/SlidingPanel.cpp
    ${FRONTEND_DIR}/worksheet/WorksheetPreviewWidget.cpp
    ${FRONTEND_DIR}/worksheet/WorksheetView.cpp
    ${FRONTEND_DIR}/widgets/BackgroundWidget.cpp
    ${FRONTEND_DIR}/widgets/ConstantsWidget.cpp
    ${FRONTEND_DIR}/widgets/ThemesComboBox.cpp
    ${FRONTEND_DIR}/widgets/ThemesWidget.cpp
    ${FRONTEND_DIR}/widgets/ExpressionTextEdit.cpp
    ${FRONTEND_DIR}/widgets/FitOptionsWidget.cpp
    ${FRONTEND_DIR}/widgets/FitParametersWidget.cpp
    ${FRONTEND_DIR}/widgets/FunctionsWidget.cpp
    ${FRONTEND_DIR}/widgets/LabelWidget.cpp
    ${FRONTEND_DIR}/widgets/ErrorBarWidget.cpp
    ${FRONTEND_DIR}/widgets/LineWidget.cpp
    ${FRONTEND_DIR}/widgets/SymbolWidget.cpp
    ${FRONTEND_DIR}/widgets/ValueWidget.cpp
    ${FRONTEND_DIR}/widgets/DatapickerImageWidget.cpp
    ${FRONTEND_DIR}/widgets/DatapickerCurveWidget.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditWidget.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditNewKeywordDialog.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditAddUnitDialog.cpp
    ${FRONTEND_DIR}/widgets/FITSHeaderEditDialog.cpp
    ${FRONTEND_DIR}/widgets/ResizableTextEdit.cpp
    ${FRONTEND_DIR}/widgets/TimedLineEdit.cpp
    ${FRONTEND_DIR}/widgets/TreeViewComboBox.cpp
    ${FRONTEND_DIR}/widgets/qxtspanslider.cpp
    ${FRONTEND_DIR}/widgets/MemoryWidget.cpp
    ${FRONTEND_DIR}/widgets/DateTimeSpinBox.cpp
    ${FRONTEND_DIR}/widgets/NumberSpinBox.cpp
    ${FRONTEND_DIR}/widgets/UTCDateTimeEdit.cpp
    ${FRONTEND_DIR}/workbook/WorkbookView.cpp
)

if(Qt${QT_VERSION_MAJOR}Mqtt_FOUND)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTConnectionManagerWidget.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTConnectionManagerDialog.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTErrorWidget.cpp)
    list(APPEND GUI_SOURCES ${FRONTEND_DIR}/datasources/MQTTSubscriptionWidget.cpp)
endif()

if(APPLE)
  list(APPEND GUI_SOURCES ${FRONTEND_DIR}/worksheet/PresenterWidget_mac.mm)
endif()

set(GUI_QRC
    ${FRONTEND_DIR}/labplot.qrc
)

set(UI_SOURCES
    ${FRONTEND_DIR}/ui/colormapswidget.ui
    ${FRONTEND_DIR}/ui/constantswidget.ui
    ${FRONTEND_DIR}/ui/PlotTemplateDialog.ui
    ${FRONTEND_DIR}/ui/exampleswidget.ui
    ${FRONTEND_DIR}/ui/functionswidget.ui
    ${FRONTEND_DIR}/ui/fitoptionswidget.ui
    ${FRONTEND_DIR}/ui/fitparameterswidget.ui
    ${FRONTEND_DIR}/ui/labelwidget.ui
    ${FRONTEND_DIR}/ui/symbolwidget.ui
    ${FRONTEND_DIR}/ui/settingsnotebookpage.ui
    ${FRONTEND_DIR}/ui/settingsgeneralpage.ui
    ${FRONTEND_DIR}/ui/settingsspreadsheetpage.ui
    ${FRONTEND_DIR}/ui/settingsworksheetpage.ui
#     ${FRONTEND_DIR}/ui/settingswelcomepage.ui
    ${FRONTEND_DIR}/ui/settingsdatasetspage.ui
    ${FRONTEND_DIR}/ui/settingsprintingpage.ui
    ${FRONTEND_DIR}/ui/datasources/asciioptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/CANOptionsWidget.ui
    ${FRONTEND_DIR}/ui/datasources/binaryoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/databasemanagerwidget.ui
    ${FRONTEND_DIR}/ui/datasources/datasetmetadatamanagerwidget.ui
    ${FRONTEND_DIR}/ui/datasources/hdf5optionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/imageoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/importdatasetwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importkaggledatasetwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importfilewidget.ui
    ${FRONTEND_DIR}/ui/datasources/importoriginlayersdialog.ui
    ${FRONTEND_DIR}/ui/datasources/importwarningsdialog.ui
    ${FRONTEND_DIR}/ui/datasources/importprojectwidget.ui
    ${FRONTEND_DIR}/ui/datasources/importsqldatabasewidget.ui
    ${FRONTEND_DIR}/ui/datasources/matiooptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/netcdfoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/rootoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/fitsoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/jsonoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/mcapoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/odsoptionswidget.ui
    ${FRONTEND_DIR}/ui/datasources/xlsxoptionswidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/aspectdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/axisdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/backgroundwidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cursordock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/infoelementdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cartesianplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/cartesianplotlegenddock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/histogramdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/barplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/boxplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/columndock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/custompointdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/errorbarwidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/imagedock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/kdeplotdock.ui
    ${FRONTEND_DIR}/ui/dockwidgets/linewidget.ui
    ${FRONTEND_DIR}/ui/dockwidgets/livedatadock.ui

=== tests/CMakeLists.txt ===
set(SRC_DIR ${labplot_SOURCE_DIR}/src)
include_directories(${SRC_DIR} ${GSL_INCLUDE_DIR})

# shared code
add_library(labplottest STATIC CommonTest.cpp analysis/AnalysisTest.cpp nsl/NSLTest.h ../src/backend/lib/Debug.cpp)
target_link_libraries(labplottest labplotnsllib Qt${QT_MAJOR_VERSION}::Test KF${KF_MAJOR_VERSION}::ConfigCore KF${KF_MAJOR_VERSION}::I18n)
add_library(labplotmetatest STATIC CommonMetaTest.cpp)
target_link_libraries(labplotmetatest labplotbackendlib labplotlib labplottest)

if(KUserFeedback_FOUND AND QT_MAJOR_VERSION EQUAL 6)
    target_link_libraries(labplottest KUserFeedbackCoreQt6 KUserFeedbackWidgetsQt6)
endif()
target_compile_definitions(labplottest PUBLIC ${LABPLOT_COMPILE_DEFINITIONS})

add_subdirectory(analysis)
add_subdirectory(backend)
add_subdirectory(cartesianplot)
add_subdirectory(import_export)
add_subdirectory(nsl)
add_subdirectory(spreadsheet)
add_subdirectory(livedata)
add_subdirectory(matrix)
add_subdirectory(multirange)
add_subdirectory(commonfrontend)

if(Cantor_FOUND)
    add_subdirectory(notebook)
endif()

option(ENABLE_TEST_DEPENDENCIES "Enable Dependencies Tests" ON)
if(ENABLE_TEST_DEPENDENCIES)
    add_executable (DependenciesTest DependenciesTest.cpp)
    target_link_libraries(DependenciesTest labplotbackendlib labplotlib labplottest)
    add_test(NAME DependenciesTest COMMAND DependenciesTest)
endif()

=== data/color-schemes/CMakeLists.txt ===
if(WIN32 OR APPLE)
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR} PATTERN "CMakeLists.txt" EXCLUDE)
else()
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)
endif()

=== data/examples/CMakeLists.txt ===
if(APPLE)
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR} PATTERN "CMakeLists.txt" EXCLUDE)
else()
    install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME} PATTERN "CMakeLists.txt" EXCLUDE)
endif()

=== data/pics/CMakeLists.txt ===
ecm_install_icons(
ICONS
sc-apps-labplot-1x-zoom.svg
sc-apps-labplot-2x-zoom.svg
sc-apps-labplot-3x-zoom.svg
sc-apps-labplot-4x-zoom.svg
sc-apps-labplot-5x-zoom.svg
sc-apps-labplot-auto-scale-all.svg
sc-apps-labplot-auto-scale-x.svg
sc-apps-labplot-auto-scale-y.svg
sc-apps-labplot-axis-horizontal.svg
sc-apps-labplot-axis-vertical.svg
sc-apps-labplot-back.svg
sc-apps-labplot-cursor-arrow.svg
sc-apps-labplot-editbreaklayout.svg
sc-apps-labplot-editgrid.svg
sc-apps-labplot-edithlayout.svg
sc-apps-labplot-editvlayout.svg
sc-apps-labplot-format-text-symbol.svg
sc-apps-labplot-forward.svg
sc-apps-labplot-json-array.svg
sc-apps-labplot-json-object.svg
sc-apps-labplot-kaggle.svg
sc-apps-labplot-matrix-new.svg
sc-apps-labplot-matrix.svg
sc-apps-labplot-maximize.svg
sc-apps-labplot-minimize.svg
sc-apps-labplot-MQTT.svg
sc-apps-labplot-plot-axis-points.svg
sc-apps-labplot-shift-down-y.svg
sc-apps-labplot-shift-left-x.svg
sc-apps-labplot-shift-right-x.svg
sc-apps-labplot-shift-up-y.svg
sc-apps-labplot-spreadsheet-new.svg
sc-apps-labplot-spreadsheet.svg
sc-apps-labplot-TeX-logo.svg
sc-apps-labplot-transform-move.svg
sc-apps-labplot-workbook-new.svg
sc-apps-labplot-workbook.svg
sc-apps-labplot-worksheet-new.svg
sc-apps-labplot-worksheet.svg
sc-apps-labplot-xy-curve-points.svg
sc-apps-labplot-xy-curve-segments.svg
sc-apps-labplot-xy-curve.svg
sc-apps-labplot-xy-equation-curve.svg
sc-apps-labplot-xy-fit-curve.svg
sc-apps-labplot-xy-plot-four-axes.svg
sc-apps-labplot-xy-plot-two-axes-centered-origin.svg
sc-apps-labplot-xy-plot-two-axes-centered.svg
sc-apps-labplot-xy-plot-two-axes.svg
sc-apps-labplot-zoom-in-x.svg
sc-apps-labplot-zoom-in-y.svg
sc-apps-labplot-zoom-out-x.svg
sc-apps-labplot-zoom-out-y.svg
sc-apps-labplot-zoom-select.svg
sc-apps-labplot-zoom-select-x.svg
sc-apps-labplot-zoom-select-y.svg
sc-apps-labplot-zoom.svg
DESTINATION ${KDE_INSTALL_ICONDIR}
THEME hicolor)

=== lib/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.17.0 FATAL_ERROR)

project(examples)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

set(CI_PROJECT_DIR $ENV{CI_PROJECT_DIR})

cmake_path(GET CI_PROJECT_DIR RELATIVE_PART RELATIVE_CI_PROJECT_DIR)

set(CI_INSTALL_PATH ${CI_PROJECT_DIR}/_staging/${RELATIVE_CI_PROJECT_DIR}/_install)

list(PREPEND CMAKE_SYSTEM_PREFIX_PATH ${CI_INSTALL_PATH})

find_package(LabPlot REQUIRED COMPONENTS SDK)

file(GLOB EXAMPLE_FOLDERS *_ex)
foreach(DIR ${EXAMPLE_FOLDERS})
    add_subdirectory(${DIR})
endforeach()

=== src/3rdparty/CMakeLists.txt ===
if(APPLE AND ENABLE_TOUCHBAR)
    add_subdirectory(kdmactouchbar)
endif()

if(ENABLE_LIBORIGIN AND NOT LIBORIGIN_FOUND)
    add_subdirectory(liborigin)
endif()

if(BUILD_READSTAT)
    include(ExternalProject)

    set(build_dir ${CMAKE_BINARY_DIR}/src/3rdparty)
    set(install_dir ${build_dir}/install)
    file(MAKE_DIRECTORY ${install_dir}/lib)
    file(MAKE_DIRECTORY ${install_dir}/include)

    set(ext_src ${build_dir}/readstat/src/readstat)
    # TODO: find easy (and portable) way to get latest version
    # curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest | grep 'browser_download_url.*.tar.gz' | cut -d\" -f4
    # curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest | jq --raw-output '.assets[0] | .browser_download_url'
    # execute_process(COMMAND "curl -s https://api.github.com/repos/WizardMac/ReadStat/releases/latest |   jq --raw-output '.assets[0] | .browser_download_url'" OUTPUT_VARIABLE ext_url)
    set(ext_version "1.1.9")
    set(ext_url https://github.com/WizardMac/ReadStat/releases/download/v${ext_version}/readstat-${ext_version}.tar.gz)
#if(WIN32)    # not used (own version on Windows)
#        set(ext_url http://sourceforge.net/projects/kst/files/3rdparty/zlib-develop-mingw-fixed.zip)
#        set(ext_configure cmake ${ext_src} ${generator} -DBUILD_SHARED_LIBS=0 ${rc_compiler} ${install_prefix} ${build_type})
#        set(ext_install ${install_target})
#        set(ext_insource OFF )
#                set(zlib_library libzlibstatic.a)
#        set(ext_make ${kst_make_program})
#else()

    # --prefix=${install_dir} does not work with spaces
    set(ext_configure ${ext_src}/configure CFLAGS=-fPIC --enable-static --disable-shared)
    set(ext_insource ON)
    #set(ext_make ${CMAKE_MAKE_PROGRAM} CXXFLAGS=-fPIC CFLAGS=-fPIC)

    set(patch_command git apply ${CMAKE_CURRENT_SOURCE_DIR}/patches/readstat-1.1.9.patch)
    set(readstat_library libreadstat.a)
#endif()
    ExternalProject_Add(3rdparty_readstat
        PREFIX ${build_dir}/readstat
        URL ${ext_url}
        SOURCE_DIR ${ext_src}
        CONFIGURE_COMMAND ${ext_configure}
        BUILD_IN_SOURCE ${ext_insource}
        PATCH_COMMAND ${patch_command}
        #BUILD_COMMAND ${ext_make}
        # libtool install does not work with spaces
        #INSTALL_COMMAND ${CMAKE_MAKE_PROGRAM} install
        INSTALL_COMMAND cp -av .libs/${readstat_library} ${install_dir}/lib/ && cp -av src/readstat.h ${install_dir}/include/
        BUILD_BYPRODUCTS ${install_dir}/lib/${readstat_library}
    )
endif()

if(BUILD_QXLSX)
    set(BUILD_SHARED_LIBS OFF)
    add_subdirectory(QXlsx EXCLUDE_FROM_ALL)
    set_property(TARGET QXlsx PROPERTY POSITION_INDEPENDENT_CODE ON)

    get_target_property(QXLSX_VERSION QXlsx VERSION)
    message(STATUS "QXlsx VERSION ${QXLSX_VERSION}")
endif()
if(BUILD_QXLSX OR QXLSX_FOUND)
    target_compile_definitions(labplotlib PRIVATE QXLSX_VERSION_STRING=\"${QXLSX_VERSION}\")
endif()

# preview.sty
if(APPLE)
    install(FILES preview.sty DESTINATION ${KDE_INSTALL_DATADIR}/latex)
else()
    install(FILES preview.sty DESTINATION ${KDE_INSTALL_DATADIR}/${PROJECT_NAME}/latex)
endif()

Include(FetchContent)

### Vector BLF ###############################
FIND_PACKAGE(PkgConfig REQUIRED)
# git download is not allowed on all system (set to ON if needed)
option(LOCAL_DBC_PARSER "Use local build of dbc parser" OFF)
option(LOCAL_VECTOR_BLF "Use local build of Vector BLF" OFF)
if(ENABLE_VECTOR_BLF)
  set(OPTION_RUN_DOXYGEN OFF CACHE BOOL "" FORCE) # disable running doxygen
  if(${LOCAL_DBC_PARSER})
      FetchContent_Declare(
        dbc_parser_cpp
        GIT_REPOSITORY https://github.com/LinuxDevon/dbc_parser_cpp.git
        GIT_TAG cc4e80c7b6e1f7a13cc47b45f226756f823888e2 # v0.4.0
      )
      # fix missing variable and keyword for fast_float
      if(NOT MSVC_FOUND)
          add_definitions (-DFASTFLOAT_VISUAL_STUDIO=0)
          add_definitions (-D__forceinline=inline)
      endif()
      # disable -Werror=maybe-uninitialized since gcc gives false positive warnings when address sanitizer is used
      if("${CMAKE_C_COMPILER_ID}" MATCHES "GNU")
          set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-error=maybe-uninitialized")
      endif()
      # dbc is the root project name
      # https://gitlab.kitware.com/cmake/cmake/-/issues/19854
      set(CMAKE_PROJECT_dbc_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/dbc_database_parser_disableTests.cmake")
      # don't install dbc_parser_cpp
      # see https://stackoverflow.com/questions/65527126/disable-install-for-fetchcontent
      # FetchContent_MakeAvailable(dbc_parser_cpp)
      FetchContent_GetProperties(dbc_parser_cpp)
      if(NOT dbc_parser_cpp_POPULATED)
          FetchContent_Populate(dbc_parser_cpp)
          add_subdirectory(${dbc_parser_cpp_SOURCE_DIR} ${dbc_parser_cpp_BINARY_DIR} EXCLUDE_FROM_ALL)
      endif()
      # headerfiles of the projects are referring to <libdbc/someheader.h> and therefore
      # the path must be added
      target_include_directories(labplotbackendlib PUBLIC ${dbc_parser_cpp_SOURCE_DIR}/include)
      target_link_libraries(labplotbackendlib dbc)
      target_compile_definitions(labplotbackendlib PRIVATE HAVE_DBC_PARSER)
      target_compile_definitions(labplotlib PUBLIC HAVE_DBC_PARSER)
      add_definitions(-DHAVE_DBC_PARSER)
  else ()
    pkg_check_modules(dbc IMPORTED_TARGET GLOBAL dbc)
    if(dbc_FOUND)
        target_link_libraries(labplotbackendlib PkgConfig::dbc)
        target_compile_definitions(labplotbackendlib PRIVATE HAVE_DBC_PARSER)
        target_compile_definitions(labplotlib PUBLIC HAVE_DBC_PARSER)
        add_definitions(-DHAVE_DBC_PARSER)
    endif()
  endif()

  if(${LOCAL_VECTOR_BLF})
    add_subdirectory(vector_blf EXCLUDE_FROM_ALL)
    set_property(TARGET Vector_BLF PROPERTY AUTOMOC OFF)
    target_include_directories(Vector_BLF PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/vector_blf/src ${CMAKE_CURRENT_BINARY_DIR}/vector_blf/src)
    list(APPEND CMAKE_SYSTEM_INCLUDE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/vector_blf/src ${CMAKE_CURRENT_BINARY_DIR}/vector_blf/src)

    target_link_libraries(labplotbackendlib Vector_BLF)
    target_compile_definitions(labplotbackendlib PRIVATE HAVE_VECTOR_BLF)
    target_compile_definitions(labplotlib PUBLIC HAVE_VECTOR_BLF)
    add_definitions(-DHAVE_VECTOR_BLF)

    get_target_property(Vector_BLF_VERSION Vector_BLF VERSION)
    if(${Vector_BLF_VERSION})
        target_compile_definitions(labplotlib PRIVATE VECTOR_BLF_VERSION_STRING=\"${Vector_BLF_VERSION}\")
    else()
        target_compile_definitions(labplotlib PRIVATE VECTOR_BLF_VERSION_STRING=\"git\")
    endif()
    message(STATUS "Vector_BLF VERSION ${Vector_BLF_VERSION}")
  else()
    pkg_check_modules(Vector_BLF IMPORTED_TARGET GLOBAL Vector_BLF)
    if(Vector_BLF_FOUND)
      target_link_libraries(labplotbackendlib ${Vector_BLF_LIBRARIES})
      target_compile_definitions(labplotbackendlib PRIVATE HAVE_VECTOR_BLF)
      target_compile_definitions(labplotlib PUBLIC HAVE_VECTOR_BLF)
      add_definitions(-DHAVE_VECTOR_BLF)
      target_compile_definitions(labplotlib PRIVATE VECTOR_BLF_VERSION_STRING=\"system\")
    endif()
  endif()
else()
  add_definitions(-DVECTOR_BLF_DISABLED)
endif()

if(LOCAL_QT_ADVANCED_DOCK_DOWNLOAD)
    FetchContent_Declare(
        qt_advanced_dock
        GIT_REPOSITORY https://github.com/githubuser0xFFFF/Qt-Advanced-Docking-System.git
        GIT_TAG a940fc29c6d1fbcb5ee1e2fecf86f20bb86a7fb6
    )
    set(CMAKE_PROJECT_QtADS_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtADS_config.cmake")
    # don't install qt_advanced_dock
    # see https://stackoverflow.com/questions/65527126/disable-install-for-fetchcontent
    # FetchContent_MakeAvailable(qt_advanced_dock)
    FetchContent_GetProperties(qt_advanced_dock)
    if(NOT qt_advanced_dock_POPULATED)
        FetchContent_Populate(qt_advanced_dock)
        add_subdirectory(${qt_advanced_dock_SOURCE_DIR} ${qt_advanced_dock_BINARY_DIR} EXCLUDE_FROM_ALL)
    endif()
    target_compile_definitions(labplotlib PRIVATE QADS_VERSION_STRING=\"git\")
elseif(LOCAL_QT_ADVANCED_DOCK_COPY)
    # https://cmake.org/cmake/help/latest/variable/CMAKE_PROJECT_INCLUDE.html
    set(CMAKE_PROJECT_QtADS_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/cmake/QtADS_config.cmake")
    set(ADS_VERSION ${labplot_VERSION})
    add_subdirectory(Qt-Advanced-Docking-System EXCLUDE_FROM_ALL)

    get_target_property(QADS_VERSION qt${QT_VERSION_MAJOR}advanceddocking VERSION)
    message(STATUS "QADS VERSION ${QADS_VERSION}")
    target_compile_definitions(labplotlib PRIVATE QADS_VERSION_STRING=\"${QADS_VERSION}\")
else()
    target_compile_definitions(labplotlib PRIVATE QADS_VERSION_STRING=\"system\")
endif()


if(LOCAL_MCAP_DOWNLOAD)
    FetchContent_Declare(mcap
        URL https://github.com/foxglove/mcap/archive/refs/tags/releases/cpp/v1.4.0.tar.gz
        URL_HASH SHA256=64ff3e51119f37ffcfaf9deecbd987a7cb4d4d9035d74a3fd3773395a470fda1 # v1.4.0
    )
    FetchContent_MakeAvailable(mcap)
    #set(_mcap_include_dir ${mcap_SOURCE_DIR}/cpp/mcap/include)
    target_include_directories(labplotbackendlib PUBLIC ${mcap_SOURCE_DIR}/cpp/mcap/include)
else ()
    target_include_directories(labplotbackendlib PUBLIC ${CMAKE_CURRENT_SOURCE_DIR}/mcap/include)
endif()

=== tests/analysis/CMakeLists.txt ===
option(ENABLE_TEST_ANALYSIS "Enable Analysis Tests" ON)

if(ENABLE_TEST_ANALYSIS)
    add_subdirectory(common)
    add_subdirectory(convolution)
    add_subdirectory(correlation)
    add_subdirectory(differentiation)
    add_subdirectory(fit)
    add_subdirectory(fourier)
    add_subdirectory(hilberttransform)
    add_subdirectory(integration)
    add_subdirectory(interpolation)
    add_subdirectory(smooth)
    add_subdirectory(fourier_transformation)
endif()

=== debian/changelog ===
labplot (2.12.1-2) unstable; urgency=medium

  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Backport upstream commit ee17e7659a97b36b58cab28b2b56cede7cd153c6 to support
    orcus 0.21.0; patch upstream_cmake-support-orcus-0.21.patch.
    (Closes: #1117346)

 -- Pino Toscano <pino@debian.org>  Fri, 14 Nov 2025 22:13:43 +0100

labplot (2.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Update install files.

 -- Pino Toscano <pino@debian.org>  Mon, 25 Aug 2025 20:12:49 +0200

=== debian/control ===
Source: labplot
Section: math
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-sequence-kf6,
 cmake (>= 3.17.0~),
 gettext,
 pkgconf,
 qt6-base-dev (>= 6.5.0~),
 qt6-base-private-dev (>= 6.5.0~),
 qt6-svg-dev (>= 6.5.0~),
 qt6-serialport-dev (>= 6.5.0~),
 extra-cmake-modules (>= 6.3.0~),
 libkf6archive-dev (>= 6.3.0~),
 libkf6completion-dev (>= 6.3.0~),
 libkf6config-dev (>= 6.3.0~),
 libkf6configwidgets-dev (>= 6.3.0~),
 libkf6coreaddons-dev (>= 6.3.0~),
 libkf6crash-dev (>= 6.3.0~),
 libkf6doctools-dev (>= 6.3.0~),
 libkf6i18n-dev (>= 6.3.0~),
 libkf6iconthemes-dev (>= 6.3.0~),
 libkf6kio-dev (>= 6.3.0~),
 libkf6newstuff-dev (>= 6.3.0~),
 libkf6parts-dev (>= 6.3.0~),
 libkf6purpose-dev (>= 6.3.0~),
 libkf6service-dev (>= 6.3.0~),
 libkf6syntaxhighlighting-dev (>= 6.3.0~),
 libkf6textwidgets-dev (>= 6.3.0~),
 libkf6widgetsaddons-dev (>= 6.3.0~),
 libkf6xmlgui-dev (>= 6.3.0~),
 libkf6userfeedback-dev,
 bison,
 libpoppler-qt6-dev (>= 19.12~) [!i386],
 libspectre-dev,
 libcfitsio-dev,
 libgsl-dev,
 libnetcdf-dev,
 libfftw3-dev,
 libhdf5-dev,
 libcerf-dev,
 zlib1g-dev,
 liblz4-dev,
 libmarkdown2-dev,
 libmatio-dev,
 libreadstat-dev,
 libeigen3-dev,
 liborcus-dev,
 libixion-dev,
 libzstd-dev,
 libcantor-dev [!i386],
 xauth <!nocheck>,
 xvfb <!nocheck>,
 locales-all <!nocheck>,
 libqt6sql6-sqlite <!nocheck>,
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/labplot
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/labplot.git
Homepage: https://labplot.kde.org/

Package: labplot
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 labplot-data (= ${source:Version}),
Description: interactive graphing and analysis of scientific data
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 Features include:
  - project-based management of data
  - project explorer for management and organization of created objects in
    different folders and sub-folders
  - spreadsheet with basic functionality for manual data entry or for
    generation of uniform and non-uniform random numbers
  - import of external ASCII data into the project for further editing and
    visualization
  - export of spreadsheet to an ASCII file
  - worksheet as the main parent object for plots, labels, etc; supports
    different layouts and zooming functions
  - export of worksheet to different formats (PDF, EPS, PNG, and SVG)
  - great variety of editing capabilities for properties of worksheet and its
    objects
  - cartesian plots, created either from imported or manually created data
    sets or via mathematical equation
  - definition of mathematical formulas is supported by syntax highlighting
    and completion and by the list of thematically grouped mathematical and
    physical constants and functions
  - analysis of plotted data is supported by many zooming and navigation
    features
  - linear and non-linear fits to data, several fit-models are predefined and
    custom models with arbitrary number of parameters can be provided

Package: labplot-data
Architecture: all
Depends: ${misc:Depends}
Description: data files for labplot
 LabPlot provides an easy way to create, manage and edit plots.  It allows you
 to produce plots based on data from a spreadsheet or on data imported from
 external files.  Plots can be exported to several pixmap and vector graphic
 formats.
 .
 This contains the data files for labplot.

=== debian/watch ===
version=4
opts="uversionmangle=s/-beta/~beta/;s/-rc/~rc/" \
https://download.kde.org/stable/labplot/labplot-(.+)\.tar\.xz
